(*
 * Module:       Installation of user equivalence specification
 *
 * Description:  Design/CPN OE Tool
 *
 * Created by:   Jens Baek Joergensen (jbj@daimi.aau.dk)
 *               Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         13/10/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OESet.sml,v $

$Log: OESet.sml,v $
Revision 1.4  1998/01/03 13:12:37  kris
Modification to make 1 tool work on state recs

Revision 1.3  1996/06/27 14:33:18  cpn
Implemented function used to set equivalence for v1.0

 Revision 1.2  1995/12/11  13:19:11  kris
 Added support for user defined encodings

 Revision 1.1  1995/11/13  13:04:38  kris
 Initial revision
 

*)

datatype OEOSSpecification = OESpec | OSSpec | OSPSpec

structure OESet =
struct

    val CPN'OEOSSpec = ref OESpec;

    fun GetOEOSSpec () = (!CPN'OEOSSpec);

    fun EquivMark (CPN'userequivmark) = OESetMark.EquivMark(CPN'userequivmark);
	
    fun EquivBE (CPN'userequivbind) = OESetBind.EquivBind(CPN'userequivbind);

    fun EncodeMarking CPN'userencodemark = 
	(if (NoOfNodes() > 1)
	     then
		 DSUI_UserAckMessage("The Key function for markings cannot be changed - Occ Graph has more than one node")
	 else
		  (CPN'OEEncode.CPN'EncodeMarkFun := CPN'userencodemark;
		   CPN'RecSearchTree.Rehash(CPN'State'recs,((!CPN'OEEncode.CPN'EncodeMarkFun) (CPN'OGState (CPN'OGUtils.GetStateRec InitNode))))))

    fun Equivalence { Mark = EquivMark,
		      Bind = EquivBE,
		      Spec = OEOSSpec } 
	= (OESetMark.EquivMark EquivMark;
	   OESetBind.EquivBind EquivBE;
	   CPN'OEOSSpec := OEOSSpec);
	   

end(*struct*);

(* Set up the default *)
OESet.EquivMark(
		(fn (CPN'n1,CPN'n2) => 
		 CPN'OGDataRecIsEq (CPN'n1,CPN'n2)));
