(*
 * Module: Contains general-purpose multi-set functions.
 *
 * Description:  Design/CPN OE/OS Graph Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *               Jens Baek Jorgensen (jbj@daimi.aau.dk)
 * Date:         01/02/96   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OEUtilities/OEMulBasics.sml,v $

$Log: OEMulBasics.sml,v $
Revision 1.2  1996/11/27 17:25:27  cpn
*** empty log message ***

Revision 1.1  1996/02/01 11:28:46  jbj
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OEUtilities/OEMulBasics.sml,v 1.2 1996/11/27 17:25:27 cpn Exp $";

structure CPN'OEMulBasics =
struct

(* The next two functions are projections. The first one computes what
is called pi_1  in our thesis. The next one computes pi_2. *)

fun proj1 empty = empty
 |  proj1 (((CPN'cf,((CPN'col1),CPN'col2)))!!CPN'rest) =
       CPN'op.ms'add(CPN'op.ms'cons(CPN'cf,CPN'col1),proj1 CPN'rest);

fun proj2 empty = empty
 |  proj2 (((CPN'cf,((CPN'col1),CPN'col2)))!!CPN'rest) =
       CPN'op.ms'add(CPN'op.ms'cons(CPN'cf,CPN'col2),proj2 CPN'rest);

end (* struct CPN'OEMulBasics *)

