
(*
 * Module:       Misc. Utils for the OE Tool
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Jens Bark Joergensen (jbj@daimi.aau.dk)
 *               Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         13/10/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OEUtils.sml,v $

$Log: OEUtils.sml,v $
Revision 1.3  1998/01/03 13:14:16  kris
Modification to make 1 tool work on state recs

Revision 1.2  1996/02/01 10:22:46  kris
Page pointers are now handled correctly

 Revision 1.1  1995/11/13  13:07:20  kris
 Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OEUtils.sml,v 1.3 1998/01/03 13:14:16 kris Exp $";

structure CPN'OEUtils =
struct

val CPN'OE_TempMarkRec = ref CPN'NoRec;

fun CPN'OESetTempMarkRec(CPN'OGState CPN'rec) = (CPN'OE_TempMarkRec := CPN'OGState CPN'rec;
						 CPN'OGState CPN'rec)
  | CPN'OESetTempMarkRec(_) = CPN'NoRec;


(* OE Equality functions *)

fun CPN'OEDataRecIsEq(CPN'OGState 
		      (CPN'rec1 as {owner = ref (ref (CPN'OGnode(noderef as {no = 0,...}))),...}),CPN'OGState CPN'rec2)  = 
    CPN'OGDataRecIsEq(CPN'OGState CPN'rec1,CPN'OGState CPN'rec2)

  | CPN'OEDataRecIsEq(CPN'OGState CPN'rec1,CPN'OGState 
		      (CPN'rec2 as {owner = ref (ref (CPN'OGnode(noderef as {no = 0,...}))),...})) = 
    CPN'OGDataRecIsEq(CPN'OGState CPN'rec1,CPN'OGState CPN'rec2)

  | CPN'OEDataRecIsEq(CPN'OGState CPN'rec1,
                      CPN'OGState (CPN'rec2 as {owner = ref (ref (CPN'OGnode(noderef as {no = CPN'n,...}))),...})) = 
                                    (!OESetMark.EquivMarkFun(CPN'OGState CPN'rec1,CPN'OGState CPN'rec2))
  | CPN'OEDataRecIsEq(rec1,rec2) = CPN'OGDataRecIsEq(rec1,rec2);


end(*struct*);

(* NOTE: The last match is neccesary since CPN'OEDataRecIsEq will also be used to test equality af Local page pointers *)
(* 0-owned record reduces to pointer compairsion *)
