(*
 * Module:
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         20/07/2000   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGCanonFromSimDataGen.sml,v $

$Log $

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGCanonFromSimDataGen.sml,v 1.1.2.2 2000/08/02 21:37:55 kris Exp $";


structure CPN'OGCanonFromSimDataGen =
struct

local
     open CPN'CodeGenUtils;
	
     val first = ref false;
	 
in    
    
    fun gen () = 
	(code_temp:=
	 "fun CPN'store_state"^
	 "(srcnoderef as ref(CPN'OGnode{state=ref(CPN'OGState srcrec),...}))\n"^
	 "=CPN'OGState\n{"; 
	 
	 
	 map
	 (fn {instlist = instlist,pgmlno = pgmlno,...}
	  =>(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields, "pg"^pgmlno);
	     (* check that record is used - otherwise an exception is rasied *)
	     map
	     (fn {instno=instno,instmlno=instmlno,...}
	      => code_temp:=(!code_temp)^"pg"^pgmlno^"'"^instno^"= "^
	      ("CPN'OGstore_pg"^pgmlno^" CPN'PS"^instmlno^",\n"))
	 instlist) handle CPN'AvlTree.ExcAvlLookup => [])
     (!CPN'NetCapture.Net);
     
     
     (CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields,"pgglobfus");
	  code_temp:=(!code_temp)^"pgglobfus= CPN'OGstore_pgglobfus(),\n")
     handle CPN'AvlTree.ExcAvlLookup =>();
	 
     if ((!CPN'env.Timedef)<>CPN'env.timenotdef)andalso(with_time())
	 then
	     code_temp:=(!code_temp)^"creationtime = time(),\n"
     else
	 ();
	     
     code_temp:=(!code_temp)^"owner = ref srcnoderef};\n";
     
     (!code_temp))

    fun gensim () = 
	(code_temp:=
	 "fun CPN'simstore_state"^
	 "(srcnoderef as ref(CPN'OGnode{state=ref(CPN'OGState srcrec),...}))\n"^
	 "=CPN'OGState\n{"; 
	 
	 
	 map
	 (fn {instlist = instlist,pgmlno = pgmlno,...}
	  =>(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields, "pg"^pgmlno);
	     (* check that record is used - otherwise an exception is rasied *)
	     map
	     (fn {instno=instno,instmlno=instmlno,...}
	      => code_temp:=(!code_temp)^"pg"^pgmlno^"'"^instno^"= ref ("^
	      ("CPN'OEstore_pg"^pgmlno^" CPN'PS"^instmlno^"),\n"))
	 instlist) handle CPN'AvlTree.ExcAvlLookup => [])
     (!CPN'NetCapture.Net);
     
     
     (CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields,"pgglobfus");
	  code_temp:=(!code_temp)^"pgglobfus= CPN'OEstore_pgglobfus(),\n")
     handle CPN'AvlTree.ExcAvlLookup =>();
	 
     if ((!CPN'env.Timedef)<>CPN'env.timenotdef)andalso(with_time())
	 then
	     code_temp:=(!code_temp)^"creationtime = time(),\n"
     else
	 ();
	     
     code_temp:=(!code_temp)^"owner = ref srcnoderef};\n";
     
     (!code_temp))
end
end;

(*
     code_temp:=(!code_temp)^(
			      (if !first then (first:=false;"fun ") else "|")^
				   "CPN'OGstore_state(srcnoderef,"^internalid^")="^
				   "CPN'OGstore_state"^funpostfix^" srcnoderef\n")*)
    
