(*
 * Module:       Design/CPN OG Tool
 *
 * Description:  Generation of for an empty state record
 *
 * Created by:   Lars Michael Kristensen (kris@daimi.au.dk)   
 *
 * Date:         12/07/2000   
 *
*)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGCreateEmptyState.sml,v $

$Log: OGCreateEmptyState.sml,v $
Revision 1.1.2.2  2000/07/20 21:34:56  kris
Added support for gloabal fusions

Revision 1.1.2.1  2000/07/13 13:41:29  kris
Initial revision


*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGCreateEmptyState.sml,v 1.1.2.2 2000/07/20 21:34:56 kris Exp $";

(* This structure generates all the basic reference types for the OG       *)
(* data structure records. Also the function to test equality of two state *)
(* records is generated here *)

structure CPN'OGCreateEmptyState =
struct

local
    
open CPN'CodeGenUtils;

  
fun gen_field CPN'first {fieldname=fieldname,colset=colset}
   = code_temp:=(!code_temp)^
                    ((if CPN'first
                      then ""
                      else ",\n")^
                      fieldname^" = ref empty"^
                      (if CPN'env.IsTimed colset
                      then ","^fieldname^"t = ref []"
                      else ""));

fun gen_localrecs (recname,ref fieldlist)
   = (code_temp:=(!code_temp)^("fun CPN'OGCreateEmptyLocal"^recname^" () = \n CPN'OGLocal"^recname^" \n {");
      if fieldlist<>nil
      then
       (gen_field true (hd fieldlist);
        map (gen_field false) (tl fieldlist))
      else
       [];
      code_temp:=(!code_temp)^"};\n")


(*
fun  gen_pageinstrectest(recname,_)
   = code_temp2:=(!code_temp2)^
                     ("| CPN'OGDataRecIsEq(CPN'OGLocal"^recname^" rec1,\n"^
                      "CPN'OGLocal"^recname^" rec2)=rec1=rec2");
*)

in

fun gen() =
 let
  val nonlocalfus= (CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields,"pgglobfus");true)

                    handle ? => false

 in

 code_temp:="";

 CPN'AvlTree.AvlAppKey(gen_localrecs, CPN'OGIdsGen.DataRecFields);

 

 
 code_temp:=(!code_temp)^"fun OGCreateEmptyState owner creationtime = \n CPN'OGState  {";

 map
  (fn {pgmlno = pgmlno, instlist = instlist,...}
     =>(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields, "pg"^pgmlno);
         (* check that record is used - otherwise an exception is rasied *)
        map
        (fn {instno=instno,...}
           => code_temp:=(!code_temp)^("pg"^pgmlno^"'"^instno^" = ref (CPN'OGCreateEmptyLocalpg"^pgmlno^" ()),\n"))
        instlist) handle CPN'AvlTree.ExcAvlLookup => [])
  (!CPN'NetCapture.Net);
  
 if nonlocalfus
 then
   code_temp:=(!code_temp)^"pgglobfus = ref (CPN'OGCreateEmptyLocalpgglobfus ()),\n"
 else
  ();
 
 if ((!CPN'env.Timedef)<>CPN'env.timenotdef)andalso(with_time())
 then
   code_temp:=(!code_temp)^"creationtime = creationtime,\n"
 else
  ();
 
 code_temp:=(!code_temp)^(
                "owner = owner};\n");


 
 (* CPN'AvlTree.AvlAppKey(gen_pageinstrectest, CPN'OGIdsGen.DataRecFields);

 code_temp2:=(!code_temp2)^";\n";*)
  
 (!code_temp)(*::[!code_temp2]*)
 
end(*let*)

end(*local*)

end(*struct*);


 
