(*
 * Module:       Create first node
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGCreateFirstGen.sml,v $

$Log: OGCreateFirstGen.sml,v $
Revision 1.1  1995/09/29 14:33:39  kris
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGCreateFirstGen.sml,v 1.1 1995/09/29 14:33:39 kris Exp $";

(* structure for generation of the function for creating the very first node by *)
(* copying the contents of the regular CPN simulator data into the global OG tables *)

structure CPN'OGCreateFirstGen =
struct

local
    
open CPN'CodeGenUtils;

in

fun gen () =

(
 code_temp:="fun CPN'OGCreateStateRec()\n"^
               "=let\n"^
                 "val staterec\n"^
                    "=CPN'OGState{\n";
 
 map
  (fn {instlist = instlist,pgmlno = pgmlno,...}
     =>(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields, "pg"^pgmlno);
         (* check that record is used - otherwise an exception is rasied *)
         map
         (fn {instno=instno,instmlno=instmlno,...}
            => code_temp:=(!code_temp)^(
                "pg"^pgmlno^"'"^instno^"="^
                  "CPN'OGstore_pg"^pgmlno^" CPN'PS"^instmlno^",\n"))
         instlist) handle CPN'AvlTree.ExcAvlLookup => [])
 (!CPN'NetCapture.Net);
                          
                                               
 (CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields,"pgglobfus");
  code_temp:=(!code_temp)^"pgglobfus=CPN'OGstore_pgglobfus(),\n")
 handle CPN'AvlTree.ExcAvlLookup =>();
 
 if ((!CPN'env.Timedef)<>CPN'env.timenotdef)andalso(with_time())
 then
  code_temp:=(!code_temp)^"creationtime=time(),\n"
 else
  (); 
 
 [!code_temp^
  "owner=ref(ref(CPN'OGnode(\n"^
          "{no=0,\n"^
            "state=ref(CPN'NoRec),\n"^
            "succlist=ref[],\n"^                               
            "predlist=ref[],\n"^
            "calcstat=ref(UnProc)})))};\n"^
      "val (insertstaterec as ref(CPN'OGState innerrec),_) \n"^
         "= CPN'RecSearchTree.Insert\n"^
            "(CPN'State'recs, staterec, CPN'OGEncode.State staterec);\n"^
      "val firstnoderef\n"^
         "= ref(CPN'OGnode\n"^
                "{state=insertstaterec,\n"^
                 "no=1 ,\n"^
                 "succlist=ref [],\n"^
                 "predlist=ref [],\n"^
                 "calcstat=ref UnProc})\n"^
    "in\n"^
      "firstnoderef\nend;\n",
    "fun CPN'OGCreateFirst () = \n"^
    "let val firstnoderef = CPN'OGCreateStateRec() in\n"^
      "CPN'OGNodeSel.NextNodeNum:=1;\n"^
      "CPN'AvlTree.AvlInsert CPN'OGNodes\n"^
        "(mkst_Node(CPN'OGUtils.GetNodeNo(!firstnoderef)),"^
         "firstnoderef)\nend;\n"
     ]
)

end(*local*)

end(*struct*);
 
 
