(*
 * Module:       Structure for recording the enabling data
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGEnabData.sml,v $

$Log: OGEnabData.sml,v $
Revision 1.1  1995/09/29 14:39:51  kris
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGEnabData.sml,v 1.1 1995/09/29 14:39:51 kris Exp $";

(* this structure records the enabling data (for immediate trans) like in SAC *)

structure CPN'OGEnabData = struct
val cands = ref ([]:((CPN'TransInst*CPN'Binding) list));
val count = ref 0;
val bindlimit_reached = ref false;
exception TransInstLimitReached;

fun init() = (cands:=[]; count:=0; bindlimit_reached:=false);

local
 val no_bindings = ref 0;
 exception BindStop
in
fun add_cand (_,[]) = ()
  | add_cand (CPN'cand,CPN'bl)
   = (if (!CPN'OGBranching.TransInstLimit<>0)andalso
         (!count = (!CPN'OGBranching.TransInstLimit))
      then raise TransInstLimitReached
      else (no_bindings:= (if !CPN'OGBranching.BindingLimit=0
                          then ~1
                          else !CPN'OGBranching.BindingLimit);
            map (fn CPN'b
                   => if !no_bindings=0
                      then (bindlimit_reached:=true;
                            raise BindStop)
                      else
                       (cands:=(CPN'cand,CPN'b)::(!cands);
                        CPN'dec no_bindings)) CPN'bl
             handle BindStop => [];
            CPN'inc count))
end(*local*);


fun get_cands() = (!cands)

end(*struct*);
