(*
 * Module:       Timed Equivalence
 *
 * Description:  Load equivalence library on timed state spaces
 *
 * Created by:   Lars Michael Kristensen (kris@daimi.au.dk)   
 *
 * Date:         12/07/2000   
 *
*)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGTimeEquivSwitch.sml,v $

$Log: OGTimeEquivSwitch.sml,v $
Revision 1.1.2.3  2000/08/06 15:10:09  kris
Resolved conflicts

Revision 1.1.2.2  2000/08/03 18:14:53  kris
renamed canonical functions

Revision 1.1.2.1  2000/07/13 13:41:27  kris
Initial revision


*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGTimeEquivSwitch.sml,v 1.1.2.3 2000/08/06 15:10:09 kris Exp $";

(* --- load the utility functions --- *)
DSUI_SetStatusBarMessage ("Loading Timed Equivalence Library ...");
use (ogpath^"OGTimeEquivUtils.sml");

(* --- load functions for generating an empty state --- *)
DSUI_SetStatusBarMessage ("Generating Basic Functions ...");
use (ogpath^"OGCreateEmptyState.sml");
usestring [(CPN'OGCreateEmptyState.gen ())];

(* --- load functions for generating canonilisation functions --- *)
DSUI_SetStatusBarMessage ("Installing Equivalence Functions ...");
use (ogpath^"OGTimeEquivCanon.sml");
usestring (CPN'TimedEquivGen.gen_CanonMarkEquiv ());

(* --- disable/enabled equivalence on the timed state space --- *);
fun TimeDisableEquivalence () = OGSetCanonical.DisableCanonFun ();
fun TimeEnableEquivalenceCT () = OGSetCanonical.EnableCanonFun (CanonMarkEquivCT);
fun TimeEnableEquivalenceOT () = OGSetCanonical.EnableCanonFun (CanonMarkEquivOT);
fun TimeEnableEquivalenceWOT () = OGSetCanonical.EnableCanonFun (CanonMarkEquivWOT);

DSUI_SetStatusBarMessage ("Timed Equivalence Library Loaded ...")
