(* 
 * Module:          Priority Queue
 *
 * Description:     General Priority Queue
 *
 * Created by:      Torben Bisgaard Haagh
 *
 * Date:            Spring 97
 *)


(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGpq-sig.sml,v $

$Log: OGpq-sig.sml,v $
Revision 1.1.2.2  2000/08/03 12:28:00  kris
Removed max and app from the signature

Revision 1.1.2.1  2000/07/20 21:36:28  kris
Initial Revision


*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGpq-sig.sml,v 1.1.2.2 2000/08/03 12:28:00 kris Exp $";

signature PRIORITYQUEUE = sig

    type key;
    val priority : key * key -> bool
	
    type 'a pq;

    exception EmptyPQ;

    val is_empty : 'a pq -> bool;

    val create : unit -> 'a pq;

    val min : 'a pq -> key * 'a;

(*
    val max : 'a pq -> key * 'a;

    val app : 'a pq -> (key * 'a -> unit) -> unit;
*)
	
    val insert : 'a pq * key * 'a  -> unit;
	
    val deletemin : 'a pq -> key * 'a;
	
    val deleteto : 'a pq * key -> (key * 'a) list;

    val wipe : 'a pq -> unit

    val size : 'a pq -> int
end
