(*
 * Module:
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGIntegerBounds.sml,v $

$Log: OGIntegerBounds.sml,v $
Revision 1.3.4.1  1999/02/03 14:10:12  mailund
stuff

Revision 1.3  1997/03/04 20:12:20  sorenchr
Fixed problem with long names, if name too long the rest is moved to the next line.

Revision 1.2  1996/02/04 13:49:51  kris
Small modification in the output

 Revision 1.1  1995/11/24  12:44:44  kris
 Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGIntegerBounds.sml,v 1.3.4.1 1999/02/03 14:10:12 mailund Exp $";

structure CPN'OGIntegerBounds =
    struct

local
open CPN'OGGetIntegerBounds;
in
	
	fun CPN'FillBlanks 0 = ""
	  | CPN'FillBlanks CPN'n = " "^(CPN'FillBlanks(CPN'n-1));

	fun CPN'PrintIntegerBounds ()
	    = let
		  val CPN'text_store = ref [] : string list ref
	      in
		  CPN'AvlTree.AvlApp 
		  (fn {plname = CPN'name,
		       upper = CPN'upper,
		       lower = CPN'lower}: CPN'OGRepIntegerPlace
		   => 
		       (CPN'text_store := 
			("  "^CPN'name
			 ^(if (size CPN'name) >= 23 
			       then "\n  "^(CPN'FillBlanks 23)
			   else CPN'FillBlanks (23-(size CPN'name)))
			 ^CPN'upper

			 ^(CPN'FillBlanks(CPN'intmax((12-size(CPN'upper)),1)))

			 ^CPN'lower^"\n")::(!CPN'text_store); 
			()),
		       CPN'IntegerListPI);
		  implode (rev (!CPN'text_store))
	      end

	fun CPN'GetAndPrintBounds () = 
	    ((CPN'IntegerBounds ());
	     "  Best Integers Bounds    Upper      Lower\n"
	    ^(CPN'PrintIntegerBounds ()))

end
end (*struct*);

(* Setup reference in the main module *)
OGSaveReport.IntegerBounds := CPN'OGIntegerBounds.CPN'GetAndPrintBounds;
OGSaveReport.IntegerBoundsGen := true;

