(*
 * Module:
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGMultiSetBounds.sml,v $

$Log: OGMultiSetBounds.sml,v $
Revision 1.5  1997/03/04 20:12:20  sorenchr
Fixed problem with long names, if name too long the rest is moved to the next line.

Revision 1.4  1996/12/12 14:40:11  cpn
Added CPN'StripNL to be used on the mac

Revision 1.3  1996/08/27 12:08:07  cpn
Mac Port v3.0.2

Revision 1.2  1996/02/04 13:51:03  kris
Removed some newlines in the output

 Revision 1.1  1995/11/24  12:45:21  kris
 Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGMultiSetBounds.sml,v 1.5 1997/03/04 20:12:20 sorenchr Exp $";

structure CPN'OGMultiSetBounds =
    struct

local
open CPN'OGGetMultiSetBounds;
in
	
	fun CPN'FillBlanks 0 = ""
	  | CPN'FillBlanks CPN'n = " "^(CPN'FillBlanks(CPN'n-1));


	fun CPN'PrintLowerBounds ()
	    = let
		  val CPN'text_store = ref [] : string list ref
	      in
		  CPN'AvlTree.AvlApp 
		  (fn {plname = CPN'name,
		       upper = CPN'upper,
		       lower = CPN'lower}: CPN'OGRepMultiSetPlace
		   => 
		       (CPN'text_store := 
			("  "^CPN'name
			 ^(if (size CPN'name) >= 20
			       then "\n  "^(CPN'FillBlanks 20)
			   else CPN'FillBlanks (20-(size CPN'name)))

			 ^CPN'lower

			 ^"\n")::(!CPN'text_store); 
			()),
		  CPN'MultiSetListPI);
		  implode (rev (!CPN'text_store))
	      end

	fun CPN'PrintUpperBounds ()
	    = let
		  val CPN'text_store = ref [] : string list ref
	      in
		  CPN'AvlTree.AvlApp 
		  (fn {plname = CPN'name,
		       upper = CPN'upper,
		       lower = CPN'lower}:CPN'OGRepMultiSetPlace
		   => 
		       (CPN'text_store := 
			("  "^CPN'name
			 ^(if (size CPN'name) >= 20
			       then "\n  "^(CPN'FillBlanks 20)
			   else CPN'FillBlanks (20-(size CPN'name)))

			 ^CPN'upper

			 ^"\n")::(!CPN'text_store); 
			()),
		  CPN'MultiSetListPI);
		  implode (rev (!CPN'text_store))
	      end

	fun CPN'GetAndPrintBounds () = 
	    ((CPN'MultiSetBounds ());
	     "\n  Best Upper Multi-set Bounds\n"
	    ^(CPN'PrintUpperBounds ())
	    ^"\n  Best Lower Multi-set Bounds\n"
	    ^(CPN'PrintLowerBounds ()))

end
end (*struct*);

(* generate code *)

(* Setup reference in the main module *)
OGSaveReport.MultiSetBounds := CPN'OGMultiSetBounds.CPN'GetAndPrintBounds;
OGSaveReport.MultiSetBoundsGen := true;

