(*
 * Module:       Creation of the Default Marking Equivalence
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *               Jens Baek Jorgensen (jbj@daimi.aau.dk)
 * Date:         01/02/96   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OEMarkDefaultGen.sml,v $

$Log: OEMarkDefaultGen.sml,v $
Revision 1.4.2.2  2000/08/14 07:38:50  kris
Fixed a buf with default equivalence on timed model -- cleaned up and made the default equivalence on markings a named function

Revision 1.4.2.1  1999/01/04 09:16:27  mailund
char vs. string

Revision 1.4  1998/03/04 15:50:02  kris
Fixed a problem with referring to creation time in the default equivalence

Revision 1.3  1998/01/03 13:11:46  kris
Modified generation of default equivalence on marking to work on staterecs

Revision 1.2  1996/12/12 14:40:42  cpn
Extension to be able to handle timed CP-nets

Revision 1.1  1996/02/01 10:18:27  kris
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OEMarkDefaultGen.sml,v 1.4.2.2 2000/08/14 07:38:50 kris Exp $";

fun MarkEquivDefaultGen ()
    = let
	  val CPN'store = ref [] : string list ref;
	  fun CPN'app CPN'st = CPN'store := CPN'st:: (!CPN'store);
      in
	  CPN'app "fun CPN'DefaultEquivMark (CPN'n1,CPN'n2) = ((\n";

	  map
	  (fn {pllist = pllist, pgname = pgname, instlist = instlist,...
	       }
	   => CPN'AvlTree.AvlApp
	       (fn {plname="",...} => ()
		 | {plname=plname, pldbid=pldbid,...}
		   => (map 
		       (fn {instno=instno,instdbid=instdbid,...} =>
			(let
			     val CPN'plikey=Cpndb.makestringdbid(pldbid)^" "^(Cpndb.makestringdbid(instdbid));
			     val CPN'colset = (#colset(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.PlaceInsts,CPN'plikey)));
			     val CPN'IsAssignedPort = 
				 ((#plitype(CPN'AvlTree.AvlLookup
					    (CPN'OGIdsGen.PlaceInsts,CPN'plikey))) =  CPN'OGIdsGen.assignedport)

			 in
			     if CPN'IsAssignedPort
				 then ()
			     else
				 (if (CPN'env.IsTimed CPN'colset)
				      then
					  CPN'app ("(case (CPN'timeop.tms'sub(OEMark."
						   ^pgname^"'"^plname^
						   " "^instno^" CPN'n1,OEMark."
						   ^pgname^"'"^plname^" "^instno^
						   " CPN'n2)) of tempty => true | _ => false) andalso\n")
				  else
				      CPN'app ("(OEMark."^pgname^"'"^plname^
					       " "^instno^" CPN'n1 == OEMark."
					       ^pgname^"'"^plname^" "^instno^
					       " CPN'n2) andalso\n"))
			 end))
		       instlist;()),
		       pllist))
	  (!CPN'NetCapture.Net);     
	  CPN'app (if (!CPN'env.Timedef)=CPN'env.timenotdef
		       then
			   "true));\n"
		   else
		       "(StateCreationTime CPN'n1) = (StateCreationTime CPN'n2)\n"^
		       ")\nhandle CPN'IllegalMultiSetSubtr => false);\n");
	  CPN'app ("OESet.EquivMark(CPN'DefaultEquivMark);\n");
	  [(implode (rev (!CPN'store)))]
      end;
