(*
 * Module:       OGMLfiles
 *
 * Description:  Functions for mapping between internal and external representation of binding elements
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         16/03/98   
 *
 * Design/CPN (tm)  Copyright (c) University of Aarhus 1998
 *)

(* $Source $

$Log: OGBindMap.sml,v $
Revision 1.1  1998/03/16 10:21:28  kris
Initial Revision


*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGBindMap.sml,v 1.1 1998/03/16 10:21:28 kris Exp $";



fun CPN'IntBEToExtBE ((CPN't,CPN'instno),CPN'b) = 
    let
	val CPN'bref = ref CPN'b
    in
	 CPN'ArcToBE1 ((CPN't,CPN'instno),CPN'bref)
    end;

(* Mapping from external representation of internal representation *)
(* extracted from ImageFiles/OGBind.sml *)

structure CPN'OGBindGenNew =
struct

local

open CPN'CodeGenUtils;

val FirstConstructor = ref true;

  fun lgen_BEToArc()
    =( patterncount:=0;
       partfuncount:=0;
       code_temp:="";
       code_storage:= ["exception BEToArcExn; \n fun CPN'BEToArc0 _ = raise BEToArcExn;\n"];

       map
          (fn {trlist = trlist, pgname = pgname,...}
            => map
                 (fn {trname = "", ...} => ()
                   | {trname = trname, trmlno = trmlno, ...}
                    => let
                         val internalid = "("^trmlno^",CPN'instno)";
                         val (intpatt,extpatt)
                            = CPN'OGBTconvGen.genBEbindpatterns trmlno 
                        in
                         newpattern("CPN'BEToArc",
                                    "(Bind."^pgname^"'"^trname^"(CPN'instno,"^extpatt^")) = "^
                                    "("^internalid^","^(intpatt)^")\n"

				    )
                        end(*let*))
                 trlist)
          (!CPN'NetCapture.Net);
                 
       if !patterncount>0
       then (* finish the last function in code_temp *)
        (code_storage:= !code_storage^^
                        [!code_temp^
                         "| CPN'BEToArc"^(makestring(!partfuncount+1))^" CPN'x=CPN'BEToArc"^
                        (makestring(!partfuncount))^" CPN'x;\n"];
         code_temp:="")
       else
        ();
	
	code_storage:= !code_storage^^
         ["fun BEToArc CPN'be=CPN'BEToArc"^
         (makestring(!partfuncount+(if !patterncount=0 then 0 else 1)))^
         " CPN'be;\n"]);
     
in    

fun gen_BEToArc() =
(lgen_BEToArc();
 !code_storage);

end(*local*)
end(*struct*);

