(*
 * Module:
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGDelete.sml,v $

$Log: OGDelete.sml,v $
Revision 1.1.2.2  2000/05/11 13:11:40  kris
Added support for timed models

Revision 1.1.2.1  2000/05/10 06:51:33  kris
Initial Revision


*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGDelete.sml,v 1.1.2.2 2000/05/11 13:11:40 kris Exp $";

(* --- delete the current occurrence graph --- *)
structure CPN'OGGlobTablesReset =
struct
    
local

open CPN'CodeGenUtils;
  
 fun gen_recsearchtree(recname,_)
    = code_storage:= ("CPN'RecSearchTree.Reset(CPN'"^recname^"'recs);\n")
                       ::(!code_storage)
in

fun gen () =
  
 (
 code_storage:=[];
  
 CPN'AvlTree.AvlApp(
  fn (csdesc as {name,...})
    => code_storage:= ("CPN'"^name^"'mss.Reset ();\n")
                       ::(!code_storage),
  CPN'env.colortabel);

 CPN'AvlTree.AvlAppKey(gen_recsearchtree, CPN'OGIdsGen.DataRecFields);

  ["fun DeleteOccGraph () = (\n"]^^
 (!code_storage)^^[
 
      if (!CPN'env.Timedef)<>CPN'env.timenotdef
      then ("CPN'TimeListsTree.Reset CPN'TimeListTree;\n")

      else "();\n",
 
	 "CPN'RecSearchTree.Reset CPN'State'recs;\n",
	 "CPN'AvlTree.AvlReset CPN'OGArcs;\n",
	 "CPN'AvlTree.AvlReset CPN'OGNodes;\n",
	 "CPN'BindSearchTree.Reset CPN'Binds;\n",
	 "CPN'OGNodeSel.NextNodeNum:=0;\n",
	 "CPN'OGNodeSel.NextArcNum:=0;\n",
	 "CPN'OGNodeSel.InitList();\n",
	 "OGSimStatetoOG();\n",
		   "());\n"]

  )

end(*local*)

end(*struct*);

(* --- generate the delete function --- *)
usestring [(implode (CPN'OGGlobTablesReset.gen ()))];
