(*
 * Module:       For generation of the OESetMark function
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         12/07/2000   
 *
 * Design/CPN (tm)  Copyright (c) University of Aarhus, Denmark 1998
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGSetMarkGen.sml,v $

$Log: OGSetMarkGen.sml,v $
Revision 1.1.2.1  2000/07/13 13:41:24  kris
Initial revision


*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/Attic/OGSetMarkGen.sml,v 1.1.2.1 2000/07/13 13:41:24 kris Exp $";

(* structure for generations of the OESetMark function *)


structure CPN'OGSetMarkGen =
struct

local
    
open CPN'CodeGenUtils;
 
fun extractfieldname ("'"::tl) fieldname
   = fieldname
  | extractfieldname (hd::tl) fieldname
   = extractfieldname tl (fieldname^hd)
  | extractfieldname nil fieldname
   = fieldname;

fun  gen_placeinstmark({OGdatarec=OGdatarec, OGdatarecfield=OGdatarecfield,
                        pli=pli,...}:CPN'OGIdsGen.PlaceInstDecr,CPN'csistimed)
   = 
    "{"^OGdatarec^"=ref(CPN'OGLocal"^
     (extractfieldname (explode OGdatarec) "")^
     "{"^OGdatarecfield^"= CPN'oldms,"^
        (if CPN'csistimed
         then (OGdatarecfield^"t = CPN'tl,")
         else "")^"...}),...}\n";

(* "(#"^OGdatarecfield^" (#"^OGdatarec^" CPN'n)) := CPN'ms"*)

val firstinst = ref false;

in


 fun gen()
    = (code_temp:="structure OESetMark=struct\n"^
                  (if (!CPN'env.Timedef)<>CPN'env.timenotdef then

                  "fun striptl tempty= empty\n"^
                    "| striptl ((CPN'coef,CPN'col,_)!!!tms1)="^
		    "(CPN'coef,CPN'col)!!(striptl tms1);\n"^

                  "fun stripms tempty=[]\n"^
                    "|stripms((_,_,CPN'tl)!!!ms1)=CPN'tl^^(stripms ms1);\n"

                   else "");
                         
       map
         (fn {pllist = pllist, pgname = pgname, instlist = instlist,...}
            => CPN'AvlTree.AvlApp
                 (fn {plname="",...} => ()
                   | {plname=plname, pldbid=pldbid,...}
		            => (firstinst:=true;
		                map
		                (fn {instno=instno,instdbid=instdbid,...}
		                   => let
		                        val CPN'p=pgname^"'"^plname;
		                        val CPN'plikey=Cpndb.makestringdbid(pldbid)^" "^(Cpndb.makestringdbid(instdbid));
		                        val CPN'pliinfo=(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.PlaceInsts,CPN'plikey));
		                        val CPN'csistimed= CPN'env.IsTimed (#colset CPN'pliinfo)
		                       in
		                         code_temp:= !code_temp^
		                          (if !firstinst then (firstinst:=false;"fun ") else "\n | ")^
		                          CPN'p^"("^instno^":Inst) (CPN'n:CPN'OGrec) CPN'newms =\n"^"let val "^
		                          "CPN'OGState "^(gen_placeinstmark (CPN'pliinfo,CPN'csistimed))^
		                          "= CPN'n in \n "^
		                            (if CPN'csistimed 
		                             then "(CPN'oldms := striptl CPN'newms;\n"^ 
						  " CPN'tl := stripms CPN'newms;\n"
		                             else "(CPN'oldms := CPN'newms;\n ")
		                            ^"()) \n end"
		                       end(*let*))
		                   instlist;
		                   code_temp:= !code_temp^(if !firstinst then "fun " else "\n | ")^
		                                pgname^"'"^plname^" _ _ _ =raise IllegalId;\n\n"
		                  ),
		                 pllist))
          (!CPN'NetCapture.Net);       
        
       [!code_temp^"end(*struct*);\n"]);
       
end(*local*)

end(*struct*);

 
