(*
 * Module:       OGTime
 *
 * Description:  Design/CPN OG Tool. Utility Function used to handle occurrence graphs with time.
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         14/04/96   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGTime.sml,v $

$Log: OGTime.sml,v $
Revision 1.2  1996/08/27 12:09:26  cpn
Mac Port v3.0.2

Revision 1.1  1996/08/08 10:36:40  cpn
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGTime.sml,v 1.2 1996/08/27 12:09:26 cpn Exp $";

exception NonexistingArc

fun CPN'OccurenceTimeGen () = 
    (if ((!CPN'env.Timedef <> CPN'env.timenotdef) andalso (with_time ()))

	 then "fun OccurrenceTime CPN'a = (CreationTime (DestNode CPN'a) handle  ExcAvlLookup => raise NonexistingArc)"

     else
	 "");

usestring ([(CPN'OccurenceTimeGen ())]);

fun CPN'StripTimeGen () =
    (if ((!CPN'env.Timedef <> CPN'env.timenotdef))
	 then "val StripTime = striptime;"
     else
	 "fun StripTime CPN'ms = CPN'ms"); 

usestring([(CPN'StripTimeGen ())]);

(* This function is used to generate the function EqualUnTimed *)

    local
        open CPN'NetCapture;
        open CPN'CodeGenUtils;

    in        
	fun CPN'gen_EqualUntimed () =
            (
             code_temp := "true)\n";
             map
             (fn {pllist = pllist, pgname = pgname, instlist = instlist,...}
              => CPN'AvlTree.AvlApp
                  (fn {plname="",...} => ()
                    | {plname=plname, pldbid=pldbid,...}
                      => ( map
                          (fn {instno=instno,instdbid=instdbid,...}
                           => (
			       let 
				   val CPN'plikey=Cpndb.makestringdbid(pldbid)^" "^(Cpndb.makestringdbid(instdbid));

				   val CPN'colset = (#colset(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.PlaceInsts,CPN'plikey)));
				   val CPN'istimed = CPN'env.IsTimed CPN'colset
			       in
                               code_temp := "(("^(if CPN'istimed then "StripTime " else "")^"(Mark."^pgname^"'"^plname^" "^instno^" CPN'n1)) == ("^(if CPN'istimed then "StripTime" else "")^"(Mark."^pgname^"'"^plname^" "^instno^" CPN'n2))) andalso \n"^(!code_temp)
			       end))
                              
                          instlist; 
                          ()),pllist))
             (!CPN'NetCapture.Net); 

	     code_temp := "fun EqualUntimed (CPN'n1,CPN'n2) = \n("^(!code_temp); 
             ([!code_temp]))
    end;

(* Generate the functions *)
usestring(CPN'gen_EqualUntimed());   

fun EqualsUntimed CPN'm = PredAllNodes(fn CPN'n => (EqualUntimed (CPN'm,CPN'n)))

(* How to determined time vs nottime *)
(* CPN'env.TimeDef <> CPN'env.timenotdef *)
