(*
 * Module:       Utilities for referencing global tables and records
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGUtils.sml,v $

$Log: OGUtils.sml,v $
Revision 1.2.4.1  2000/08/06 15:05:08  kris
added function NodeRecToStateRec

Revision 1.2  1996/06/06 10:09:38  cpn
Integrated OE/OS Tool modifications (OEOS)

Revision 1.1  1995/09/29 14:59:20  kris
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/OGUtils.sml,v 1.2.4.1 2000/08/06 15:05:08 kris Exp $";

(* utilities for easy referencing of global tables and fields in records *)

structure CPN'OGUtils =
struct
   
(* fun NodeRefToNode (CPN'OGnode{no,...}):Node = no;

 fun ArcRecToArc (CPN'OGarc{no,...}):Arc = no; *)

 exception CPN'NodeRecToStateRecExn;
 fun NodeRecToStateRec (CPN'OGnode {state = ref CPN'staterec,...}) = CPN'staterec
   | NodeRecToStateRec _ = raise CPN'NodeRecToStateRecExn;

 fun NodeToNodeRef (CPN'n:Node)
    = CPN'AvlTree.AvlLookup (CPN'OGNodes,mkst_Node CPN'n);

 fun NodeToNodeRec (CPN'n:Node) = !(NodeToNodeRef CPN'n);

 fun ArcToArcRef (CPN'a:Arc)
    = CPN'AvlTree.AvlLookup (CPN'OGArcs,mkst_Arc CPN'a);
 
 fun ArcToArcRec (CPN'a:Arc) = !(ArcToArcRef CPN'a);


 fun GetStateRec (CPN'n:Node)
    = let val ref(CPN'OGnode{state=
               ref(CPN'OGState staterec),...})
             = (NodeToNodeRef CPN'n)
      in staterec end;

 fun GetNodeNo (CPN'OGnode CPN'nrec) = #no CPN'nrec;

 fun GetNodeSucclist (CPN'OGnode CPN'nrec) = #succlist CPN'nrec;
 fun GetNodePredlist (CPN'OGnode CPN'nrec) = #predlist CPN'nrec;

 fun GetNodeCalcStat (CPN'OGnode CPN'nrec) = #calcstat CPN'nrec;

 fun GetArcInscr (CPN'OGarc CPN'arec) = #inscr CPN'arec;
  fun GetArcNo (CPN'OGarc CPN'arec) = #no CPN'arec;

 fun GetArcSrc (CPN'OGarc CPN'arec) = #src CPN'arec;
 fun GetArcDest (CPN'OGarc CPN'arec) = #dest CPN'arec;

end(*struct*);

