(*
 * Module:       Report of the home properties functions
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGDead.sml,v $

 $Log: OGDead.sml,v $
 Revision 1.2  1996/05/14 12:41:34  cpn
 Fixed a bug in output when more than 5 dead markings

 Revision 1.1  1995/11/24 12:44:02  kris
 Initial revision
 

 *)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGDead.sml,v 1.2 1996/05/14 12:41:34 cpn Exp $";

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGDead.sml,v 1.2 1996/05/14 12:41:34 cpn Exp $";

structure CPN'OGDead =
    struct

	fun DeadMarkings () = 
	    let
		val CPN'hml = (ListDeadMarkings ());
		(* if we only have 5 or less home markings sort them *)
		val CPN'nohm = (length CPN'hml);
		    
		val CPN'all = (CPN'nohm = (NoOfNodes ()));
		val CPN'lt5 = (length CPN'hml <= 5);
		val CPN'none = (CPN'nohm = 0);
		    
		fun CPN'Print [] CPN'n = "" (* None will be printed *)
		  | CPN'Print (CPN'el1::(CPN'el2::CPN'rest)) 5 = 
		    mkst_Node(CPN'el1)^",...]"
		  | CPN'Print (CPN'el1::(CPN'el2::CPN'rest)) CPN'n = 
		    mkst_Node(CPN'el1)^","^(CPN'Print (CPN'el2::CPN'rest) (CPN'n+1))
		  | CPN'Print (CPN'el1::CPN'rest) CPN'n = 
		    mkst_Node(CPN'el1)^(CPN'Print CPN'rest (CPN'n+1))	

		fun CPN'SortAndPrint CPN'lst = 
		    let
			(* Simple bobble-sort - since we only have 5 elements *)
			fun CPN'sort CPN'lst = 
			    let
				fun CPN'insert [] CPN'el = CPN'el::[]
				  | CPN'insert ((CPN'el1:int)::CPN'l) (CPN'el2:int) =
				    if (CPN'el1 < CPN'el2)
					then CPN'el1::(CPN'insert CPN'l CPN'el2)
				    else
					(CPN'el2::(CPN'el1::CPN'l))
					
				fun CPN'sort' [] CPN'nl = CPN'nl
				  | CPN'sort' (CPN'el::CPN'tl) CPN'nl =
				    CPN'sort' CPN'tl (CPN'insert CPN'nl CPN'el) 
			    in
				CPN'sort' CPN'lst [] 
			    end
			
			
		    in
			"["^(CPN'Print (CPN'sort CPN'lst) 1)^"]"
		    end
		
		fun PrintDeadMarkings CPN'l =
		    if CPN'all 
			then "All"
		    else
			(if CPN'none
			     then
				 "None"
			 else
			     (if CPN'lt5
				  then
				      (CPN'SortAndPrint CPN'l)
			      else
				  makestring(length(CPN'l))^" ["^CPN'Print CPN'l 1))
	    in
		"  Dead Markings:  "^(PrintDeadMarkings (CPN'hml))^"\n"
	    end
	
    end (* struct CPN'OGDead *);

(* Setup reference in the main module *)
OGSaveReport.DeadMarkings := CPN'OGDead.DeadMarkings;
OGSaveReport.DeadMarkingsGen := true;
