(*
 * Module:       Report of the liveness properties functions
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGDeadTIs.sml,v $

$Log: OGDeadTIs.sml,v $
Revision 1.2  1996/02/04 13:46:26  kris
Removed some newline in output

 Revision 1.1  1995/11/24  12:44:13  kris
 Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGDeadTIs.sml,v 1.2 1996/02/04 13:46:26 kris Exp $";

structure CPN'OGDeadTIs =
struct

    fun DeadTransitions () =
	let
	    val CPN'DeadTIsList = CPN'AvlTree.AvlNew():string CPN'AvlTree.avltree;
	    val CPN'DeadTIs = (ListDeadTIs ());
	    val CPN'text_store = ref [] : string list ref;

	    (* Insert in list which ensures that the output respect *)
	    (* users settings for st_TI *)

	    fun CPN'BuildDeadTIsList [] = ()
	      | CPN'BuildDeadTIsList (CPN'el::CPN'tl) =
		((CPN'AvlTree.AvlInsert CPN'DeadTIsList ((st_TI CPN'el),(st_TI CPN'el)));
		 CPN'BuildDeadTIsList CPN'tl)

	    val _ = (CPN'BuildDeadTIsList CPN'DeadTIs);
	in

	    "  Dead Transitions Instances: "
	    ^(if (length (TI.All) = length (CPN'DeadTIs))
		  then
		      "All"
	      else
		  (if (length (CPN'DeadTIs) = 0)
		       then 
			   "None"
		   else
		       (
			CPN'AvlTree.AvlApp (fn CPN'name => 
					    (CPN'text_store := (CPN'name)::"\n  "::(!CPN'text_store)),CPN'DeadTIsList);
			"\n"^(implode (rev (!CPN'text_store)))))^"\n")
	end
    
    
end (* struct CPN'OGLiveTIs *);

(* Setup reference in the main module *)
OGSaveReport.DeadTIs := CPN'OGDeadTIs.DeadTransitions;
OGSaveReport.DeadTIsGen := true;
