(*
 * Module:
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGFairness.sml,v $

$Log: OGFairness.sml,v $
Revision 1.3  1997/03/04 20:12:20  sorenchr
Fixed problem with long names, if name too long the rest is moved to the next line.

Revision 1.2  1996/02/04 13:48:27  kris
Removed some newlines in the output

 Revision 1.1  1995/11/24  12:44:23  kris
 Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGFairness.sml,v 1.3 1997/03/04 20:12:20 sorenchr Exp $";

structure CPN'OGFairness = 
    struct

    fun CPN'Fairness () =
	let
	    val CPN'TIsList = CPN'AvlTree.AvlNew():string CPN'AvlTree.avltree;
	    val CPN'text_store = ref [] : string list ref;

	    (* Insert in list which ensures that the output respect *)
	    (* users settings for st_TI *)

	    fun CPN'FillBlanks 0 = ""
	      | CPN'FillBlanks CPN'n = " "^(CPN'FillBlanks(CPN'n-1));

	    fun CPN'FairnessToString Impartial = "Impartial"
	      | CPN'FairnessToString Fair = "Fair"
	      | CPN'FairnessToString Just = "Just"
	      | CPN'FairnessToString No_Fairness = "No Fairness"

	    fun CPN'BuildTIsList [] = ()
	      | CPN'BuildTIsList (CPN'el::CPN'tl) =
		((CPN'AvlTree.AvlInsert 
		  CPN'TIsList 
		  ((st_TI CPN'el),
		   ("  "^(st_TI CPN'el)^
		    (if (size (st_TI CPN'el) >= 23)
			then "\n  "^(CPN'FillBlanks 23)
		    else CPN'FillBlanks (23-(size(st_TI CPN'el))))^
		    (CPN'FairnessToString(TIsFairness [CPN'el])))));
		 CPN'BuildTIsList CPN'tl)
		
	    val _ = (CPN'BuildTIsList TI.All);
	in
	    
	     
	     "\n\n Fairness Properties"^"\n------------------------------------------------------------------------"
	     ^(if (length (PredAllSccs (fn CPN'n => not(SccTrivial CPN'n))) = 0)
		   then "\n  No infinite occurrence sequences.\n" 
	       else
		   (CPN'AvlTree.AvlApp (fn CPN'text => 
					(CPN'text_store := (CPN'text)::"\n"::(!CPN'text_store)),CPN'TIsList);
		    (implode (rev (!CPN'text_store)))^"\n"))
	end
    
    
end (* struct CPN'OGLiveTIs *);

(* Setup reference in the main module *)
OGSaveReport.FairnessProperties := CPN'OGFairness.CPN'Fairness;
OGSaveReport.FairnessGen := true;

