(*
 * Module:
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGIntegerBoundsGen.sml,v $

$Log: OGIntegerBoundsGen.sml,v $
Revision 1.2.4.2  2000/08/01 13:22:25  kris
Modified report so that assigned port are not contained in the report

Revision 1.2.4.1  1999/02/03 14:10:14  mailund
stuff

Revision 1.2  1996/05/14 12:39:57  cpn
Suppoer for timed O-graphs

Revision 1.1  1995/11/24 12:44:58  kris
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGIntegerBoundsGen.sml,v 1.2.4.2 2000/08/01 13:22:25 kris Exp $";

type CPN'OGRepIntegerPlace = {plname:string,upper:string,lower:string};

structure CPN'OGIntegerBoundsGen =
struct

    local
	open CPN'NetCapture;
	open CPN'CodeGenUtils;



    in
	fun gen_IntegerBoundsSeq () =
	    (
	     code_temp := "\n()) end(*struct*)\n";
 	     map
	     (fn {pllist = pllist, pgname = pgname, instlist = instlist,...}
	      => CPN'AvlTree.AvlApp
		  (fn {plname="",...} => ()
		    | {plname=plname, pldbid=pldbid,...}
		      => ( map
			  (fn {instno=instno,instdbid,...}
			   => let
				  val CPN'plikey=Cpndb.makestringdbid(pldbid)^" "^(Cpndb.makestringdbid(instdbid));

				  val CPN'colset = (#colset(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.PlaceInsts,CPN'plikey)));
				  val CPN'istimed = CPN'env.IsTimed CPN'colset
				  val CPN'key = pgname^"'"^plname^instno;
				  val CPN'PI = "PI."^pgname^"'"^plname^" "^instno;
				  val CPN'MPI = "("^(if CPN'istimed then "StripTime o " else "")^"(Mark."^pgname^"'"^plname^" "^instno
				  val CPN'IsAssignedPort = 
				      ((#plitype(CPN'AvlTree.AvlLookup
						 (CPN'OGIdsGen.PlaceInsts,CPN'plikey))) 
				       =  CPN'OGIdsGen.assignedport)

			      in
                                  if CPN'IsAssignedPort
                                      then ()
				  else
				      code_temp := "\n(let val CPN'name = st_PI("^CPN'PI^") \n in \n CPN'AvlTree.AvlInsert CPN'IntegerListPI (\""^CPN'key^"\",{plname = CPN'name,upper = makestring(UpperInteger("^CPN'MPI^")))),lower = makestring(LowerInteger("^CPN'MPI^"))))}) end); "^(!code_temp)
			      end(*let*))
			  instlist; 
			  ()),pllist))
	     (!CPN'NetCapture.Net); 
(* "structure CPN'OGGetIntegerBounds = \n struct 		val CPN'IntegerListPI = CPN'AvlTree.AvlNew():CPN'OGRepIntegerPlace CPN'AvlTree.avltree; \n fun CPN'IntegerBounds () = (CPN'AvlTree.AvlReset CPN'IntegerListPI;" *)
	     code_temp := "structure CPN'OGGetIntegerBounds = \n struct val CPN'IntegerListPI = CPN'AvlTree.AvlNew():CPN'OGRepIntegerPlace CPN'AvlTree.avltree; \n fun CPN'IntegerBounds () = (CPN'AvlTree.AvlReset CPN'IntegerListPI;"^(!code_temp); 
	     ([!code_temp]))
    end
     
end (* struct CPN'OGIntegerBounds *);

usestring (CPN'OGIntegerBoundsGen.gen_IntegerBoundsSeq ());
