(*
 * Module:       Report of the liveness properties functions
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGLiveTIs.sml,v $

$Log: OGLiveTIs.sml,v $
Revision 1.2  1996/02/04 13:50:30  kris
Small modification in the output

 Revision 1.1  1995/11/24  12:45:09  kris
 Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGLiveTIs.sml,v 1.2 1996/02/04 13:50:30 kris Exp $";

structure CPN'OGLiveTIs =
struct

    fun LiveTransitions () =
	let
	    val CPN'LiveTIsList = CPN'AvlTree.AvlNew():string CPN'AvlTree.avltree;
	    val CPN'LiveTIs = (ListLiveTIs ());
	    val CPN'text_store = ref [] : string list ref;

	    (* Insert in list which ensures that the output respect *)
	    (* users settings for st_TI *)

	    fun CPN'BuildLiveTIsList [] = ()
	      | CPN'BuildLiveTIsList (CPN'el::CPN'tl) =
		((CPN'AvlTree.AvlInsert CPN'LiveTIsList ((st_TI CPN'el),(st_TI CPN'el)));
		 CPN'BuildLiveTIsList CPN'tl)

	    val _ = (CPN'BuildLiveTIsList CPN'LiveTIs);
	in

	    "  Live Transitions Instances: "
	    ^(if (length (TI.All) = length (CPN'LiveTIs))
		  then
		      "All"
	      else
		  (if (length (CPN'LiveTIs) = 0)
		       then 
			   "None"
		   else
		       (
			CPN'AvlTree.AvlApp (fn CPN'name => 
					    (CPN'text_store := (CPN'name)::"\n  "::(!CPN'text_store)),CPN'LiveTIsList);
			"\n"^(implode (rev (!CPN'text_store)))))^"\n")
	end
	    
    
end (* struct CPN'OGLiveTIs *);

(* Setup reference in the main module *)
OGSaveReport.LiveTIs := CPN'OGLiveTIs.LiveTransitions;
OGSaveReport.LiveTIsGen := true;
