(*
 * Module:
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGMultiSetBoundsGen.sml,v $

$Log: OGMultiSetBoundsGen.sml,v $
Revision 1.2.4.2  2000/08/01 13:22:27  kris
Modified report so that assigned port are not contained in the report

Revision 1.2.4.1  1999/02/03 14:10:14  mailund
stuff

Revision 1.2  1996/05/14 12:36:35  cpn
Support for timed O-graphs

Revision 1.1  1995/11/24 12:45:32  kris
Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGMultiSetBoundsGen.sml,v 1.2.4.2 2000/08/01 13:22:27 kris Exp $";

type CPN'OGRepMultiSetPlace = {plname:string,upper:string,lower:string};

structure CPN'OGMultiSetBoundsGen =
struct

    local
	open CPN'NetCapture;
	open CPN'CodeGenUtils;



    in
	fun gen_MultiSetBoundsSeq () =
	    (
	     code_temp := "\n()) end(*struct*)\n";
 	     map
	     (fn {pllist = pllist, pgname = pgname, instlist = instlist,...}
	      => CPN'AvlTree.AvlApp
		  (fn {plname="",...} => ()
		    | {plname=plname, pldbid=pldbid,...}
		      => ( map
			  (fn {instno=instno,instdbid=instdbid,...}
			   => let
			       val CPN'key = pgname^"'"^plname^instno;
			       val CPN'PI = "PI."^pgname^"'"^plname^" "^instno;
			       val CPN'plikey=Cpndb.makestringdbid(pldbid)^" "^(Cpndb.makestringdbid(instdbid));
			       val CPN'colset = (#colset(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.PlaceInsts,CPN'plikey)));
			       val CPN'primecolset = CPN'env.GetPrimename(CPN'colset);
			       val CPN'IsTimed = CPN'env.IsTimed CPN'colset;
			       val CPN'MPI = "("^(if CPN'IsTimed then "StripTime o " else "")^"(Mark."^pgname^"'"^plname^" "^instno;
			       val CPN'IsAssignedPort = 
				   ((#plitype(CPN'AvlTree.AvlLookup
					      (CPN'OGIdsGen.PlaceInsts,CPN'plikey))) 
				    =  CPN'OGIdsGen.assignedport)
				   
			      in
                                  if CPN'IsAssignedPort
                                      then ()
				  else


			       code_temp := "\n(let val CPN'name = st_PI("^CPN'PI^") \n in \n CPN'AvlTree.AvlInsert CPN'MultiSetListPI (\""^CPN'key^"\",{plname = CPN'name,upper = mkst_ms'"^CPN'primecolset^"(CPN'UpperMultiSet("^CPN'MPI^")))),lower = mkst_ms'"^CPN'primecolset^"(CPN'LowerMultiSet("^CPN'MPI^"))))}) end); "^(!code_temp)




			      end(*let*))
			  instlist; 
			  ()),pllist))
	     (!CPN'NetCapture.Net); 
(*"structure CPN'OGGetMultiSetBounds = \n struct 		val CPN'MultiSetListPI = CPN'AvlTree.AvlNew():CPN'OGRepMultiSetPlace CPN'AvlTree.avltree; \n fun CPN'MultiSetBounds () = (CPN'AvlTree.AvlReset CPN'MultiSetListPI;"*)
	     code_temp := "structure CPN'OGGetMultiSetBounds = struct val CPN'MultiSetListPI = CPN'AvlTree.AvlNew():CPN'OGRepMultiSetPlace CPN'AvlTree.avltree;\n fun CPN'MultiSetBounds () = (CPN'AvlTree.AvlReset CPN'MultiSetListPI;"^(!code_temp); 
	     ([!code_temp]))
    end
     
end (* struct CPN'OGMultiSetBoundsGen *);

usestring (CPN'OGMultiSetBoundsGen.gen_MultiSetBoundsSeq ());
