(*
 * Module:       Report statistics
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* $Source: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGStats.sml,v $

$Log: OGStats.sml,v $
Revision 1.2  1996/02/04 13:51:41  kris
Small modification in the output

 Revision 1.1  1995/11/24  12:45:39  kris
 Initial revision
 

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/oga/OGMLfiles/ReportFiles/OGStats.sml,v 1.2 1996/02/04 13:51:41 kris Exp $";

structure CPN'Stats = 
struct
    
    fun GetStats()= " Statistics\n------------------------------------------------------------------------\n"
	^"  Occurrence Graph  \n"
	^"    Nodes:  "^makestring(NoOfNodes())^"\n"
	^"    Arcs:   "^makestring(NoOfArcs())^"\n"
	^"    Secs:   "^makestring(NoOfSecs())^"\n"
	^"    Status: "^(if EntireGraphCalculated() then "Full" else "Partial")^"\n\n"
	^(if SccGraphCalculated () 
	      then
		  "  Scc Graph \n"
		  ^"    Nodes:  "^makestring(SccNoOfNodes())^"\n"
		  ^"    Arcs:   "^makestring(SccNoOfArcs())^"\n"
		  ^"    Secs:   "^makestring(SccNoOfSecs())^"\n"
	  else
	      "")
end (* struct Stats *);

(* Setup function in the main report module *)
OGSaveReport.Statistics := CPN'Stats.GetStats;
(* Indicate that statistics cide has been generated *)
OGSaveReport.StatisticsGen := true;






