(*
 * Module:       GetSimulatorState.sml
 *
 * Description:  Generation of function used to extract the current simulator state/
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         19/01/98   
 *
 * Design/CPN (tm)  Copyright (c) University of Aarhus, Denmark 1998
 *)

(* 
$Source: /users/cpn/designcpnR/src/current/perf/PerfMLfiles/GetSimulatorState.sml,v $

$Log: GetSimulatorState.sml,v $
Revision 1.3  1998/10/06 11:37:06  wells
Initial Version

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/perf/PerfMLfiles/GetSimulatorState.sml,v 1.3 1998/10/06 11:37:06 wells Exp $";

structure CPN'GetSimulatorState =
struct

local
    
open CPN'CodeGenUtils;

in

fun gen () =

(
 code_temp:= "fun GetCurrentSimState ()\n"^
               "=let\n"^
                 "val staterec\n"^
                    "=CPN'OGState{\n";
 
 map
  (fn {instlist = instlist,pgmlno = pgmlno,...}
     =>(CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields, "pg"^pgmlno);
         (* check that record is used - otherwise an exception is rasied *)
         map
         (fn {instno=instno,instmlno=instmlno,...}
            => code_temp:=(!code_temp)^(
                "pg"^pgmlno^"'"^instno^"= ref ("^
                  "CPN'OEstore_pg"^pgmlno^" CPN'PS"^instmlno^"),\n"))
         instlist) handle CPN'AvlTree.ExcAvlLookup => [])
 (!CPN'NetCapture.Net);
                          
                                               
 (CPN'AvlTree.AvlLookup(CPN'OGIdsGen.DataRecFields,"pgglobfus");
  code_temp:=(!code_temp)^"pgglobfus=CPN'OEstore_pgglobfus(),\n")
 handle CPN'AvlTree.ExcAvlLookup =>();
 
 if ((!CPN'env.Timedef)<>CPN'env.timenotdef)andalso(with_time())
 then
  code_temp:=(!code_temp)^"creationtime=(!CPN'CreationTime),\n"
 else
  (); 
 
 [!code_temp^
  "owner=ref(ref(CPN'OGnode(\n"^
          "{no=0,\n"^
            "state=ref(CPN'NoRec),\n"^
            "succlist=ref[],\n"^                               
            "predlist=ref[],\n"^
            "calcstat=ref(UnProc)})))};\n"^
    "in\n"^
    "staterec\n"^
      "end;\n"]
)

end(*local*)

end(*struct*);












