(*
 * Module:       Design/CPN Performance Analysis Library
 *
 * Description:  Deleting performance analysis records
 *
 * Created by:   Bo Lindstrm (blind@daimi.aau.dk)   
 *               Lisa Wells   (wells@daimi.aau.dk)
 *
 * Date:         March 1998   
 *
 * Design/CPN   Copyright (c) University of Aarhus 1998
 *)

(*
$Source: /users/cpn/designcpnR/src/current/perf/PerfMLfiles/PerfDeleteRecords.sml,v $

$Log: PerfDeleteRecords.sml,v $
Revision 1.3.2.1  1999/05/20 06:43:28  wells
Port to sml97

Revision 1.3  1999/02/03 12:24:53  wells
updateLogFile removed from Data Collectors

Revision 1.2  1998/10/26 08:52:11  wells
structure names standardized, CPN' added to parameter names,
updateLogFile added

Revision 1.1  1998/10/06 11:02:29  wells
Initial Version

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/perf/PerfMLfiles/PerfDeleteRecords.sml,v 1.3.2.1 1999/05/20 06:43:28 wells Exp $";

structure Perf'DeleteDC = struct

fun deleteAll (Perf'Env.datacolls CPN'p) = 
    ((#uilist (CPN'p)):= ([]);
    (#urlist (CPN'p)):= ([]);
    (#tilist (CPN'p)):= ([]);
    (#trlist (CPN'p)):= ([]));


fun deleteByName (CPN'names:string list, []) = []
  | deleteByName ([], CPN'recordList) = CPN'recordList
  | deleteByName 
    (CPN'names,({name=CPN'name,theSV=CPN's,obsFun=CPN'ob,predFun=CPN'pr,
		 logFile=CPN'lf,logFileName=CPN'lfn,counter=CPN'c,
		 updateSV=CPN'u}::CPN'ps)) = 
    let 
	val toBeDeleted = Perf'Env.listLookup (CPN'name,CPN'names)
    in
	if toBeDeleted
	    then (deleteByName (CPN'names,CPN'ps))
	else (({name=CPN'name,theSV=CPN's,obsFun=CPN'ob,predFun=CPN'pr,
		logFile=CPN'lf,counter=CPN'c,logFileName=CPN'lfn,
		updateSV=CPN'u})::(deleteByName (CPN'names,CPN'ps)))
    end;

fun deleteDCByName (CPN'names:string list) (Perf'Env.datacolls CPN'p) =
    ((#tilist CPN'p):= 
     (deleteByName (CPN'names,(!(#tilist CPN'p))));
     (#trlist CPN'p):= 
     (deleteByName (CPN'names,(!(#trlist CPN'p))));
     (#uilist CPN'p):= 
     (deleteByName (CPN'names,(!(#uilist CPN'p))));
     (#urlist CPN'p):= 
     (deleteByName (CPN'names,(!(#urlist CPN'p)))));
    
end; (* struct *)
