(*
 * Module:       Functions for settings attributes and options
 *
 * Description:  Design/CPN OG Tool
 *
 * Created by:   Lars Kristensen (kris@daimi.aau.dk)   
 *
 * Date:         29/09/95   
 *
 * Design/CPN (tm)  Copyright (c) Meta Software Corp 1989--1995
 *)

(* 
 $Source $ 

 $Log: PerfSetAttrOptions.sml,v $
 Revision 1.1  1998/10/06 11:02:37  wells
 Initial Version

*)

val rcsid = "$Header: /users/cpn/designcpnR/src/current/perf/PerfMLfiles/PerfSetAttrOptions.sml,v 1.1 1998/10/06 11:02:37 wells Exp $";

structure OGSet = struct

    val stringreppiref = ref (fn (CPN'pa,CPN'pl,CPN'in) =>
			      (CPN'pa)^"'"^(CPN'pl)^" "^(CPN'in))

    val stringreptiref = ref (fn (CPN'pa, CPN'tr, CPN'in) =>
			      (CPN'pa)^"'"^(CPN'tr)^" "^(CPN'in))

    val stringrepberef = ref (fn (CPN'tr, CPN'be) =>
			      CPN'tr^": "^CPN'be)

    val stringrepmarkref = ref (fn (CPN'pl, CPN'ma) =>
				CPN'pl^": "^CPN'ma)
		
    fun StringRepOptions'PI (userfilterfun) = stringreppiref := userfilterfun;
	
    fun StringRepOptions'TI (userfilterfun) = stringreptiref := userfilterfun;
	
    fun StringRepOptions'BE (userfilterfun) = stringrepberef := userfilterfun;
	
    fun StringRepOptions'Mark (userfilterfun) = stringrepmarkref := userfilterfun;


end (*struct*)

